using DTO;
using Shared;
using StubApi;

var builder = WebApplication.CreateBuilder(args);

builder.Services.AddScoped<IUserService<UserDTO>, UserService>();
// Add services to the container.

builder.Services.AddControllers();
builder.Services.AddOpenApiDocument(options => {
    options.PostProcess = document =>
    {
        document.Info = new NSwag.OpenApiInfo
        {
            Version = "v1",
            Title = "WtfAPI",
            Description = "What The Fantasy Site API",
            TermsOfService = "",
            Contact = new NSwag.OpenApiContact
            {
                Name = "The PM Mobile What The Fantasy team",
                Url = ""
            },
            License = new NSwag.OpenApiLicense
            {
                Name = "No license",
                Url = "https://license.fr"
            }
        };
    };
});


// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseOpenApi(); // Active la documentation OpenAPI
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
